# ncurses 5.9 - patch 20120901 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 5.9 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 5.9 are in the subdirectory
# 	ftp://invisible-island.net/ncurses/5.9
#
# ------------------------------------------------------------------------------
# ftp://invisible-island.net/ncurses/5.9/ncurses-5.9-20120901.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Sep  2 01:02:56 UTC 2012
# ------------------------------------------------------------------------------
# NEWS                      |   10 ++
# configure.in              |  170 ++++++++++++++++++++++----------------------
# dist.mk                   |    4 -
# ncurses/curses.priv.h     |    4 -
# ncurses/tinfo/access.c    |    4 -
# ncurses/tinfo/lib_tputs.c |    4 -
# ncurses/trace/visbuf.c    |    4 -
# ncurses/tty/hardscroll.c  |   15 ++-
# package/debian/changelog  |    4 -
# package/ncurses.spec      |    2 
# test/movewindow.c         |    3 
# 11 files changed, 118 insertions(+), 106 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.1945 
--- ncurses-5.9-20120826+/NEWS	2012-08-26 21:12:55.000000000 +0000
+++ ncurses-5.9-20120901/NEWS	2012-09-01 23:35:55.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.1945 2012/08/26 21:12:55 tom Exp $
+-- $Id: NEWS,v 1.1949 2012/09/01 23:35:55 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,12 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20120901
+	+ add a null-pointer check in _nc_flush (cf: 20120825).
+	+ fix a case in _nc_scroll_optimize() where the _oldnums_list array
+	  might not be allocated.
+	+ improve comparisons in configure.in for unset shell variables.
+
 20120826
 	+ increase size of ncurses' output-buffer, in case of very small
 	  initial screen-sizes.
@@ -69,7 +75,7 @@
 	+ update test/configure, adding check for tinfo library.
 	+ improve limit-checks for the getch fifo (report by Werner Fink).
 	+ fix a remaining mismatch between $with_echo and the symbols updated
-	  by CF_DISABLE_ECHO affecting parameters for mk-2nd.awk (report by
+	  for CF_DISABLE_ECHO affecting parameters for mk-2nd.awk (report by
 	  Sven Joachim, cf:  20120317).
 	+ modify followup check for pkg-config's library directory in the
 	  --enable-pc-files option to validate syntax (report by Sven Joachim,
Index: configure.in
Prereq:  1.552 
--- ncurses-5.9-20120826+/configure.in	2012-08-04 14:52:27.000000000 +0000
+++ ncurses-5.9-20120901/configure.in	2012-09-01 19:53:17.000000000 +0000
@@ -28,14 +28,14 @@
 dnl
 dnl Author: Thomas E. Dickey 1995-on
 dnl
-dnl $Id: configure.in,v 1.552 2012/08/04 14:52:27 tom Exp $
+dnl $Id: configure.in,v 1.553 2012/09/01 19:53:17 tom Exp $
 dnl Process this file with autoconf to produce a configure script.
 dnl
 dnl See http://invisible-island.net/autoconf/ for additional information.
 dnl
 dnl ---------------------------------------------------------------------------
 AC_PREREQ(2.13.20020210)
-AC_REVISION($Revision: 1.552 $)
+AC_REVISION($Revision: 1.553 $)
 AC_INIT(ncurses/base/lib_initscr.c)
 AC_CONFIG_HEADER(include/ncurses_cfg.h:include/ncurses_cfg.hin)
 
@@ -62,7 +62,7 @@
 	[  --without-ada           suppress check for Ada95, don't build demo],
 	[cf_with_ada=$withval],
 	[cf_with_ada=yes])
-if test x"$cf_with_ada" = xyes
+if test "x$cf_with_ada" = xyes
 then
 	cf_PROG_CC="gnatgcc gcc cc"
 else
@@ -190,7 +190,7 @@
     CF_MIXEDCASE_FILENAMES
 else
     cf_cv_mixedcase=$enable_mixedcase
-    if test "$enable_mixedcase" = "yes" ; then
+    if test "x$enable_mixedcase" = "xyes" ; then
         AC_DEFINE(MIXEDCASE_FILENAMES)
     fi
 fi
@@ -212,8 +212,8 @@
 AC_MSG_CHECKING(if you have specified an install-prefix)
 AC_ARG_WITH(install-prefix,
 	[  --with-install-prefix   prefixes actual install-location ($DESTDIR)],
-	[case "$withval" in #(vi
-	yes|no) #(vi
+	[case "x$withval" in #(vi
+	xyes|xno) #(vi
 		;;
 	*)	DESTDIR="$withval"
 		;;
@@ -250,7 +250,7 @@
 	[with_shared=$withval],
 	[with_shared=no])
 AC_MSG_RESULT($with_shared)
-test "$with_shared" = "yes" && cf_list_models="$cf_list_models shared"
+test "x$with_shared" = "xyes" && cf_list_models="$cf_list_models shared"
 
 AC_MSG_CHECKING(if you want to build static libraries)
 AC_ARG_WITH(normal,
@@ -258,7 +258,7 @@
 	[with_normal=$withval],
 	[with_normal=yes])
 AC_MSG_RESULT($with_normal)
-test "$with_normal" = "yes" && cf_list_models="$cf_list_models normal"
+test "x$with_normal" = "xyes" && cf_list_models="$cf_list_models normal"
 
 AC_MSG_CHECKING(if you want to build debug libraries)
 AC_ARG_WITH(debug,
@@ -266,7 +266,7 @@
 	[with_debug=$withval],
 	[with_debug=yes])
 AC_MSG_RESULT($with_debug)
-test "$with_debug" = "yes" && cf_list_models="$cf_list_models debug"
+test "x$with_debug" = "xyes" && cf_list_models="$cf_list_models debug"
 
 AC_MSG_CHECKING(if you want to build profiling libraries)
 AC_ARG_WITH(profile,
@@ -274,7 +274,7 @@
 	[with_profile=$withval],
 	[with_profile=no])
 AC_MSG_RESULT($with_profile)
-test "$with_profile" = "yes" && cf_list_models="$cf_list_models profile"
+test "x$with_profile" = "xyes" && cf_list_models="$cf_list_models profile"
 
 fi
 
@@ -341,9 +341,9 @@
 		[with_dlsym=$withval],
 		[with_dlsym=yes])
 	AC_MSG_RESULT($with_dlsym)
-	if test "$with_dlsym" = yes ; then
+	if test "x$with_dlsym" = xyes ; then
 		CF_FUNC_DLSYM
-		if test "$with_gpm" != yes ; then
+		if test "x$with_gpm" != xyes ; then
 			CF_VERBOSE(assuming soname for gpm is $with_gpm)
 			cf_cv_gpm_soname="$with_gpm"
 		else
@@ -365,13 +365,13 @@
 
 if test X"$CC_G_OPT" = X"" ; then
 	CC_G_OPT='-g'
-	test -n "$GCC" && test "${ac_cv_prog_cc_g}" != yes && CC_G_OPT=''
+	test -n "$GCC" && test "x${ac_cv_prog_cc_g}" != xyes && CC_G_OPT=''
 fi
 AC_SUBST(CC_G_OPT)
 
 if test X"$CXX_G_OPT" = X"" ; then
 	CXX_G_OPT='-g'
-	test -n "$GXX" && test "${ac_cv_prog_cxx_g}" != yes && CXX_G_OPT=''
+	test -n "$GXX" && test "x${ac_cv_prog_cxx_g}" != xyes && CXX_G_OPT=''
 fi
 AC_SUBST(CXX_G_OPT)
 
@@ -549,7 +549,7 @@
 	[with_big_core=no],
 	[with_big_core=no])])
 AC_MSG_RESULT($with_big_core)
-test "$with_big_core" = "yes" && AC_DEFINE(HAVE_BIG_CORE)
+test "x$with_big_core" = "xyes" && AC_DEFINE(HAVE_BIG_CORE)
 
 ### ISO C only guarantees 512-char strings, we have tables which load faster
 ### when constructed using "big" strings.  More than the C compiler, the awk
@@ -562,7 +562,7 @@
 AC_MSG_RESULT($with_big_strings)
 
 USE_BIG_STRINGS=0
-test "$with_big_strings" = "yes" && USE_BIG_STRINGS=1
+test "x$with_big_strings" = "xyes" && USE_BIG_STRINGS=1
 AC_SUBST(USE_BIG_STRINGS)
 
 ###	use option --enable-termcap to compile in the termcap fallback support
@@ -573,7 +573,7 @@
 	[with_termcap=no])
 AC_MSG_RESULT($with_termcap)
 
-if test "$with_termcap" != "yes" ; then
+if test "x$with_termcap" != "xyes" ; then
 	if test "$use_database" = no ; then
 		if test -z "$with_fallback" ; then
 			AC_ERROR(You have disabled the database w/o specifying fallbacks)
@@ -602,7 +602,7 @@
 	[with_getcap=$enableval],
 	[with_getcap=no])
 AC_MSG_RESULT($with_getcap)
-test "$with_getcap" = "yes" && AC_DEFINE(USE_GETCAP)
+test "x$with_getcap" = "xyes" && AC_DEFINE(USE_GETCAP)
 
 AC_MSG_CHECKING(if translated termcaps will be cached in ~/.terminfo)
 AC_ARG_ENABLE(getcap-cache,
@@ -610,7 +610,7 @@
 	[with_getcap_cache=$enableval],
 	[with_getcap_cache=no])
 AC_MSG_RESULT($with_getcap_cache)
-test "$with_getcap_cache" = "yes" && AC_DEFINE(USE_GETCAP_CACHE)
+test "x$with_getcap_cache" = "xyes" && AC_DEFINE(USE_GETCAP_CACHE)
 
 fi
 
@@ -621,7 +621,7 @@
 	[with_home_terminfo=$enableval],
 	[with_home_terminfo=yes])
 AC_MSG_RESULT($with_home_terminfo)
-test "$with_home_terminfo" = "yes" && AC_DEFINE(USE_HOME_TERMINFO)
+test "x$with_home_terminfo" = "xyes" && AC_DEFINE(USE_HOME_TERMINFO)
 
 AC_MSG_CHECKING(if you want to use restricted environment when running as root)
 AC_ARG_ENABLE(root-environ,
@@ -629,7 +629,7 @@
 	[with_root_environ=$enableval],
 	[with_root_environ=yes])
 AC_MSG_RESULT($with_root_environ)
-test "$with_root_environ" = yes && AC_DEFINE(USE_ROOT_ENVIRON)
+test "x$with_root_environ" = xyes && AC_DEFINE(USE_ROOT_ENVIRON)
 
 ###   Use option --enable-symlinks to make tic use symlinks, not hard links
 ###   to reduce storage requirements for the terminfo database.
@@ -640,7 +640,7 @@
 
 # soft links (symbolic links) are useful for some systems where hard links do
 # not work, or to make it simpler to copy terminfo trees around.
-if test "$ac_cv_func_symlink" = yes ; then
+if test "x$ac_cv_func_symlink" = xyes ; then
     AC_MSG_CHECKING(if tic should use symbolic links)
     AC_ARG_ENABLE(symlinks,
 	[  --enable-symlinks       make tic use symbolic links not hard links],
@@ -653,7 +653,7 @@
 # no reason to make this choice optional - use the hard links.
 if test "$with_symlinks" = no ; then
     AC_MSG_CHECKING(if tic should use hard links)
-    if test "$ac_cv_func_link" = yes ; then
+    if test "x$ac_cv_func_link" = xyes ; then
 	with_links=yes
     else
 	with_links=no
@@ -661,8 +661,8 @@
     AC_MSG_RESULT($with_links)
 fi
 
-test "$with_links" = yes && AC_DEFINE(USE_LINKS)
-test "$with_symlinks" = yes && AC_DEFINE(USE_SYMLINKS)
+test "x$with_links" = xyes && AC_DEFINE(USE_LINKS)
+test "x$with_symlinks" = xyes && AC_DEFINE(USE_SYMLINKS)
 
 ###   use option --enable-broken-linker to force on use of broken-linker support
 AC_MSG_CHECKING(if you want broken-linker support code)
@@ -673,7 +673,7 @@
 AC_MSG_RESULT($with_broken_linker)
 
 BROKEN_LINKER=0
-if test "$with_broken_linker" = yes ; then
+if test "x$with_broken_linker" = xyes ; then
 	AC_DEFINE(BROKEN_LINKER)
 	BROKEN_LINKER=1
 elif test "$DFT_LWR_MODEL" = shared ; then
@@ -694,7 +694,7 @@
 	[with_bsdpad=$enableval],
 	[with_bsdpad=no])
 AC_MSG_RESULT($with_bsdpad)
-test "$with_bsdpad" = yes && AC_DEFINE(BSD_TPUTS)
+test "x$with_bsdpad" = xyes && AC_DEFINE(BSD_TPUTS)
 
 ###   use option --enable-widec to turn on use of wide-character support
 NCURSES_CH_T=chtype
@@ -724,7 +724,7 @@
 	[with_widec=$enableval],
 	[with_widec=no])
 AC_MSG_RESULT($with_widec)
-if test "$with_widec" = yes ; then
+if test "x$with_widec" = xyes ; then
 	LIB_SUFFIX="w${LIB_SUFFIX}"
 	AC_DEFINE(USE_WIDEC_SUPPORT)
 	AC_DEFINE(NCURSES_WIDECHAR)
@@ -734,7 +734,7 @@
 	# with_overwrite=no
 	NCURSES_CH_T=cchar_t
 	AC_CHECK_FUNCS(putwc btowc wctob mbtowc wctomb mblen mbrlen mbrtowc wcsrtombs mbsrtowcs wcstombs mbstowcs)
-	if test "$ac_cv_func_putwc" != yes ; then
+	if test "x$ac_cv_func_putwc" != xyes ; then
 		CF_UTF8_LIB
 		if test "$cf_cv_utf8_lib" != no ; then
 			NCURSES_LIBUTF8=1
@@ -776,7 +776,7 @@
 	[with_lp64=$default_with_lp64])
 AC_MSG_RESULT($with_lp64)
 
-if test "$with_lp64" = yes ; then
+if test "x$with_lp64" = xyes ; then
 	cf_cv_enable_lp64=1
 else
 	cf_cv_enable_lp64=0
@@ -793,7 +793,7 @@
 	[with_tparm_varargs=yes])
 AC_MSG_RESULT($with_tparm_varargs)
 NCURSES_TPARM_VARARGS=0
-test "$with_tparm_varargs" = yes && NCURSES_TPARM_VARARGS=1
+test "x$with_tparm_varargs" = xyes && NCURSES_TPARM_VARARGS=1
 AC_SUBST(NCURSES_TPARM_VARARGS)
 
 ###   use option --disable-tic-depends to make libtic not explicitly depend on ncurses/ncursesw
@@ -876,7 +876,7 @@
 	[with_rcs_ids=$withval],
 	[with_rcs_ids=no])
 AC_MSG_RESULT($with_rcs_ids)
-test "$with_rcs_ids" = yes && AC_DEFINE(USE_RCS_IDS)
+test "x$with_rcs_ids" = xyes && AC_DEFINE(USE_RCS_IDS)
 
 ###############################################################################
 CF_MAN_PAGES([ captoinfo clear infocmp infotocap tabs tic toe tput tset ])
@@ -891,7 +891,7 @@
 	[with_ext_funcs=$enableval],
 	[with_ext_funcs=yes])
 AC_MSG_RESULT($with_ext_funcs)
-if test "$with_ext_funcs" = yes ; then
+if test "x$with_ext_funcs" = xyes ; then
 	NCURSES_EXT_FUNCS=1
 	AC_DEFINE(HAVE_ASSUME_DEFAULT_COLORS)
 	AC_DEFINE(HAVE_CURSES_VERSION)
@@ -918,7 +918,7 @@
 	[with_sp_funcs=$enableval],
 	[with_sp_funcs=no])
 AC_MSG_RESULT($with_sp_funcs)
-if test "$with_sp_funcs" = yes ; then
+if test "x$with_sp_funcs" = xyes ; then
 	NCURSES_SP_FUNCS=1
 	AC_DEFINE(NCURSES_SP_FUNCS)
 	GENERATED_SP_FUNCS=generated
@@ -935,9 +935,9 @@
 	[with_term_driver=$enableval],
 	[with_term_driver=no])
 AC_MSG_RESULT($with_term_driver)
-if test "$with_term_driver" = yes ; then
+if test "x$with_term_driver" = xyes ; then
 	AC_DEFINE(USE_TERM_DRIVER)
-	if test "$with_sp_funcs" != yes ; then
+	if test "x$with_sp_funcs" != xyes ; then
 		AC_MSG_ERROR(The term-driver option relies upon sp-funcs)
 	fi
 fi
@@ -950,7 +950,7 @@
 	[with_ext_const=no])
 AC_MSG_RESULT($with_ext_const)
 NCURSES_CONST='/*nothing*/'
-if test "$with_ext_const" = yes ; then
+if test "x$with_ext_const" = xyes ; then
 	NCURSES_CONST=const
 fi
 AC_SUBST(NCURSES_CONST)
@@ -963,8 +963,8 @@
 	[with_ext_colors=no])
 AC_MSG_RESULT($with_ext_colors)
 NCURSES_EXT_COLORS=0
-if test "$with_ext_colors" = yes ; then
-	if test "$with_widec" != yes ; then
+if test "x$with_ext_colors" = xyes ; then
+	if test "x$with_widec" != xyes ; then
 		AC_MSG_ERROR(This option applies only to wide-character library)
 	else
 		# cannot be ABI 5 since it changes sizeof(cchar_t)
@@ -983,7 +983,7 @@
 	[with_ext_mouse=no])
 AC_MSG_RESULT($with_ext_mouse)
 NCURSES_MOUSE_VERSION=1
-if test "$with_ext_mouse" = yes ; then
+if test "x$with_ext_mouse" = xyes ; then
 	NCURSES_MOUSE_VERSION=2
 	CF_NCURSES_ABI_6
 fi
@@ -995,7 +995,7 @@
 	[with_no_padding=$enableval],
 	[with_no_padding=$with_ext_funcs])
 AC_MSG_RESULT($with_no_padding)
-test "$with_no_padding" = yes && AC_DEFINE(NCURSES_NO_PADDING)
+test "x$with_no_padding" = xyes && AC_DEFINE(NCURSES_NO_PADDING)
 
 AC_CHECK_SIZEOF([signed char], 0)
 if test "$ac_cv_sizeof_signed_char" = 1 ; then
@@ -1009,7 +1009,7 @@
 	[with_signed_char=$enableval],
 	[with_signed_char=no])
 AC_MSG_RESULT($with_signed_char)
-test "$with_signed_char" != yes && NCURSES_SBOOL="char"
+test "x$with_signed_char" != xyes && NCURSES_SBOOL="char"
 AC_SUBST(NCURSES_SBOOL)
 
 ###   use option --enable-sigwinch to turn on use of SIGWINCH logic
@@ -1019,7 +1019,7 @@
 	[with_sigwinch=$enableval],
 	[with_sigwinch=$with_ext_funcs])
 AC_MSG_RESULT($with_sigwinch)
-test "$with_sigwinch" = yes && AC_DEFINE(USE_SIGWINCH)
+test "x$with_sigwinch" = xyes && AC_DEFINE(USE_SIGWINCH)
 
 ###   use option --enable-tcap-names to allow user to define new capabilities
 AC_MSG_CHECKING(if you want user-definable terminal capabilities like termcap)
@@ -1029,7 +1029,7 @@
 	[with_tcap_names=$with_ext_funcs])
 AC_MSG_RESULT($with_tcap_names)
 NCURSES_XNAMES=0
-test "$with_tcap_names" = yes && NCURSES_XNAMES=1
+test "x$with_tcap_names" = xyes && NCURSES_XNAMES=1
 AC_SUBST(NCURSES_XNAMES)
 
 ###############################################################################
@@ -1048,7 +1048,7 @@
 	[  --enable-hard-tabs      compile with hard-tabs code],,
 	[enable_hard_tabs=$with_develop])
 AC_MSG_RESULT($enable_hard_tabs)
-test "$enable_hard_tabs" = yes && AC_DEFINE(USE_HARD_TABS)
+test "x$enable_hard_tabs" = xyes && AC_DEFINE(USE_HARD_TABS)
 
 ###   use option --enable-xmc-glitch to turn on use of magic-cookie optimize
 AC_MSG_CHECKING(if you want limited support for xmc)
@@ -1056,7 +1056,7 @@
 	[  --enable-xmc-glitch     compile with support for xmc (magic-cookie)],,
 	[enable_xmc_glitch=$with_develop])
 AC_MSG_RESULT($enable_xmc_glitch)
-test "$enable_xmc_glitch" = yes && AC_DEFINE(USE_XMC_SUPPORT)
+test "x$enable_xmc_glitch" = xyes && AC_DEFINE(USE_XMC_SUPPORT)
 
 ###############################################################################
 # These are just experimental, probably should not be in a package:
@@ -1068,7 +1068,7 @@
 	[with_assumed_color=$enableval],
 	[with_assumed_color=yes])
 AC_MSG_RESULT($with_assumed_color)
-test "$with_assumed_color" = yes && AC_DEFINE(USE_ASSUMED_COLOR)
+test "x$with_assumed_color" = xyes && AC_DEFINE(USE_ASSUMED_COLOR)
 
 ###   use option --enable-hashmap to turn on use of hashmap scrolling logic
 AC_MSG_CHECKING(if you want hashmap scrolling-optimization code)
@@ -1077,7 +1077,7 @@
 	[with_hashmap=$enableval],
 	[with_hashmap=yes])
 AC_MSG_RESULT($with_hashmap)
-test "$with_hashmap" = yes && AC_DEFINE(USE_HASHMAP)
+test "x$with_hashmap" = xyes && AC_DEFINE(USE_HASHMAP)
 
 ###   use option --enable-colorfgbg to turn on use of $COLORFGBG environment
 AC_MSG_CHECKING(if you want colorfgbg code)
@@ -1086,7 +1086,7 @@
 	[with_colorfgbg=$enableval],
 	[with_colorfgbg=no])
 AC_MSG_RESULT($with_colorfgbg)
-test "$with_colorfgbg" = yes && AC_DEFINE(USE_COLORFGBG)
+test "x$with_colorfgbg" = xyes && AC_DEFINE(USE_COLORFGBG)
 
 ###   use option --enable-interop to turn on use of bindings used for interop
 AC_MSG_CHECKING(if you want interop bindings)
@@ -1097,7 +1097,7 @@
 AC_MSG_RESULT($with_exp_interop)
 
 NCURSES_INTEROP_FUNCS=0
-test "$with_exp_interop" = yes && NCURSES_INTEROP_FUNCS=1
+test "x$with_exp_interop" = xyes && NCURSES_INTEROP_FUNCS=1
 AC_SUBST(NCURSES_INTEROP_FUNCS)
 
 # This is still experimental (20080329), but should ultimately be moved to
@@ -1112,7 +1112,7 @@
 			[use_pthreads_eintr=$enableval],
 			[use_pthreads_eintr=no])
 		AC_MSG_RESULT($use_pthreads_eintr)
-		if test $use_pthreads_eintr = yes ; then
+		if test "x$use_pthreads_eintr" = xyes ; then
 			AC_DEFINE(USE_PTHREADS_EINTR)
 		fi])
 
@@ -1122,22 +1122,22 @@
 		[use_weak_symbols=$enableval],
 		[use_weak_symbols=no])
 	AC_MSG_RESULT($use_weak_symbols)
-	if test "$use_weak_symbols" = yes ; then
+	if test "x$use_weak_symbols" = xyes ; then
 		CF_WEAK_SYMBOLS
 	else
 		cf_cv_weak_symbols=no
 	fi
 
-	if test $cf_cv_weak_symbols = yes ; then
+	if test "x$cf_cv_weak_symbols" = xyes ; then
 		AC_DEFINE(USE_WEAK_SYMBOLS)
 	fi
 fi
 
 PTHREAD=
-if test "$with_pthread" = "yes" ; then
+if test "x$with_pthread" = "xyes" ; then
     AC_DEFINE(USE_PTHREADS)
     enable_reentrant=yes
-    if test $cf_cv_weak_symbols = yes ; then
+    if test "x$cf_cv_weak_symbols" = xyes ; then
         PTHREAD=-lpthread
     fi
 fi
@@ -1153,12 +1153,12 @@
 	[with_reentrant=$enableval],
 	[with_reentrant=no])
 AC_MSG_RESULT($with_reentrant)
-if test "$with_reentrant" = yes ; then
+if test "x$with_reentrant" = xyes ; then
 	cf_cv_enable_reentrant=1
 	cf_cv_enable_opaque="NCURSES_INTERNALS"
 	NCURSES_OPAQUE=1
 	NCURSES_SIZE_T=int
-	if test $cf_cv_weak_symbols = yes ; then
+	if test "x$cf_cv_weak_symbols" = xyes ; then
 		CF_REMOVE_LIB(LIBS,$LIBS,pthread)
 		CF_ADD_LIB(pthread,TEST_LIBS)
 		CF_ADD_LIB(pthread,TEST_LIBS2)
@@ -1198,7 +1198,7 @@
 	[with_safe_sprintf=$enableval],
 	[with_safe_sprintf=no])
 AC_MSG_RESULT($with_safe_sprintf)
-test "$with_safe_sprintf" = yes && AC_DEFINE(USE_SAFE_SPRINTF)
+test "x$with_safe_sprintf" = xyes && AC_DEFINE(USE_SAFE_SPRINTF)
 
 ###   use option --disable-scroll-hints to turn off use of scroll-hints scrolling logic
 # when hashmap is used scroll hints are useless
@@ -1209,7 +1209,7 @@
 	[with_scroll_hints=$enableval],
 	[with_scroll_hints=yes])
 AC_MSG_RESULT($with_scroll_hints)
-test "$with_scroll_hints" = yes && AC_DEFINE(USE_SCROLL_HINTS)
+test "x$with_scroll_hints" = xyes && AC_DEFINE(USE_SCROLL_HINTS)
 fi
 
 AC_MSG_CHECKING(if you want experimental wgetch-events code)
@@ -1218,14 +1218,14 @@
 	[with_wgetch_events=$enableval],
 	[with_wgetch_events=no])
 AC_MSG_RESULT($with_wgetch_events)
-test "$with_wgetch_events" = yes && AC_DEFINE(NCURSES_WGETCH_EVENTS)
+test "x$with_wgetch_events" = xyes && AC_DEFINE(NCURSES_WGETCH_EVENTS)
 
 ###############################################################################
 CF_HELP_MESSAGE(Testing/development Options:)
 
 ###	use option --disable-echo to suppress full display compiling commands
 CF_DISABLE_ECHO
-if test "$enable_echo" = yes; then
+if test "x$enable_echo" = xyes; then
 	ECHO_LINK=
 else
 	ECHO_LINK='@ echo linking $@ ... ;'
@@ -1244,7 +1244,7 @@
 if test "x$with_warnings" = "xyes"; then
  	CF_ADD_ADAFLAGS(-gnatg)
 	CF_GCC_WARNINGS(Wdeclaration-after-statement Wextra Wno-unknown-pragmas Wswitch-enum)
-	if test "$cf_with_cxx" = yes ; then
+	if test "x$cf_with_cxx" = xyes ; then
 		CF_GXX_WARNINGS(Wno-unused)
 	fi
 fi
@@ -1275,7 +1275,7 @@
 ###	use option --enable-expanded to generate certain macros as functions
 AC_ARG_ENABLE(expanded,
 	[  --enable-expanded       test: generate functions for certain macros],
-	[test "$enableval" = yes && AC_DEFINE(NCURSES_EXPANDED)])
+	[test "x$enableval" = xyes && AC_DEFINE(NCURSES_EXPANDED)])
 
 ###	use option --disable-macros to suppress macros in favor of functions
 AC_ARG_ENABLE(macros,
@@ -1298,7 +1298,7 @@
 [cf_with_trace=$cf_all_traces])
 AC_MSG_RESULT($cf_with_trace)
 
-if test "$cf_with_trace" = yes ; then
+if test "x$cf_with_trace" = xyes ; then
 	LIB_TRACING=all
 	ADA_TRACE=TRUE
 	CF_ADD_CFLAGS(-DTRACE)
@@ -1356,7 +1356,7 @@
 
 # check for ISC (this may also define _POSIX_SOURCE)
 # Note: even non-Posix ISC needs <sys/bsdtypes.h> to declare fd_set
-if test "$ISC" = yes ; then
+if test "x$ISC" = xyes ; then
 	AC_CHECK_LIB(cposix,main)
 	AC_CHECK_LIB(inet,bzero,CF_ADD_LIB(inet))dnl also 'select()'
 fi
@@ -1418,7 +1418,7 @@
 times \
 vsnprintf \
 )
-if test "$with_getcap" = "yes" ; then
+if test "x$with_getcap" = "xyes" ; then
 	CF_CGETENT
 fi
 
@@ -1433,7 +1433,7 @@
 CF_SUBST_IF(["$cf_cv_func_vsscanf" = vsscanf], HAVE_VSSCANF, 1, 0)
 
 dnl FIXME (may need this) AC_SYS_RESTARTABLE_SYSCALLS
-if test "$cross_compiling" = yes ; then
+if test "x$cross_compiling" = xyes ; then
 	AC_MSG_WARN(cross compiling: assume setvbuf params not reversed)
 else
 	AC_FUNC_SETVBUF_REVERSED
@@ -1452,7 +1452,7 @@
 if test "$cf_cv_func_openpty" != no ; then
     AC_DEFINE_UNQUOTED(USE_OPENPTY_HEADER,<$cf_cv_func_openpty>)
     AC_DEFINE(USE_XTERM_PTY)
-    if test "$cf_cv_lib_util" = yes ; then
+    if test "x$cf_cv_lib_util" = xyes ; then
         CF_ADD_LIB(util,TEST_LIBS)
     fi
 fi
@@ -1570,7 +1570,7 @@
 dnl At the moment we support no other Ada95 compiler.
 	if test "$cf_with_ada" != "no" ; then
 		CF_PROG_GNAT
-		if test	"$cf_cv_prog_gnat_correct" = yes; then
+		if test	"x$cf_cv_prog_gnat_correct" = xyes; then
 			CF_ADD_ADAFLAGS(-gnatpn)
 			CF_FIXUP_ADAFLAGS
 
@@ -1606,7 +1606,7 @@
 AC_MSG_CHECKING(for library subsets)
 LIB_SUBSETS=
 
-if test "$cf_with_progs" = yes || test "$with_ticlib" != no || test "$with_termcap" != no; then
+if test "x$cf_with_progs" = xyes || test "$with_ticlib" != no || test "$with_termcap" != no; then
 	LIB_SUBSETS="${LIB_SUBSETS}ticlib"
 	if test "$with_ticlib" != no ; then
 		LIB_SUBSETS="${LIB_SUBSETS} "
@@ -1616,7 +1616,7 @@
 fi
 
 LIB_SUBSETS="${LIB_SUBSETS}termlib"
-test "$with_ext_funcs" = yes && LIB_SUBSETS="${LIB_SUBSETS}+ext_tinfo"
+test "x$with_ext_funcs" = xyes && LIB_SUBSETS="${LIB_SUBSETS}+ext_tinfo"
 
 if test "$with_termlib" != no ; then
 	LIB_SUBSETS="${LIB_SUBSETS} "
@@ -1640,8 +1640,8 @@
 	esac
 fi
 
-test "$with_widec"     = yes && LIB_SUBSETS="${LIB_SUBSETS}+widechar"
-test "$with_ext_funcs" = yes && LIB_SUBSETS="${LIB_SUBSETS}+ext_funcs"
+test "x$with_widec"     = xyes && LIB_SUBSETS="${LIB_SUBSETS}+widechar"
+test "x$with_ext_funcs" = xyes && LIB_SUBSETS="${LIB_SUBSETS}+ext_funcs"
 
 AC_MSG_RESULT($LIB_SUBSETS)
 
@@ -1666,7 +1666,7 @@
 AC_MSG_RESULT($DFT_OBJ_SUBDIR)
 
 # libtool thinks it can make c++ shared libraries (perhaps only g++)
-if test "$cf_with_cxx" = yes ; then
+if test "x$cf_with_cxx" = xyes ; then
 AC_MSG_CHECKING(c++ library-dependency suffix)
 if test "$with_libtool" != "no"; then
 	CXX_LIB_SUFFIX=$DFT_DEP_SUFFIX
@@ -1678,7 +1678,7 @@
 fi
 
 # do not want -ldl in build except as needed for -lncurses dependency
-if test "$with_dlsym" = yes ; then
+if test "x$with_dlsym" = xyes ; then
 if test $DFT_LWR_MODEL = shared || \
    test $DFT_LWR_MODEL = libtool ; then
 	CF_REMOVE_LIB(LIBS,$LIBS,dl)
@@ -1689,13 +1689,13 @@
 # TICS_LIST and TINFO_LIST are needed to build libtic.so and libterm.so, but
 # do not need libdl
 TICS_LIST=
-if test "$with_dlsym" = yes ; then
+if test "x$with_dlsym" = xyes ; then
 	CF_REMOVE_LIB(TINFO_LIST,$SHLIB_LIST,dl)
 fi
 
 if test "$with_ticlib" != no ; then
 
-	if test "$with_ticlib" != yes ; then
+	if test "x$with_ticlib" != xyes ; then
 		TICS_NAME=$with_ticlib
 		TICS_ARG_SUFFIX="${with_ticlib}`echo ${DFT_ARG_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
 		TICS_DEP_SUFFIX="${with_ticlib}`echo ${DFT_DEP_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
@@ -1719,7 +1719,7 @@
 
 if test "$with_termlib" != no ; then
 
-	if test "$with_termlib" != yes ; then
+	if test "x$with_termlib" != xyes ; then
 		TINFO_NAME=$with_termlib
 		TINFO_SUFFIX="`echo ${DFT_LIB_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
 		TINFO_ARG_SUFFIX="${with_termlib}`echo ${DFT_ARG_SUFFIX}|sed -e "s/^${LIB_SUFFIX}//"`"
@@ -1760,7 +1760,7 @@
 	TINFO_NAME=${LIB_NAME}
 	TINFO_SUFFIX=${DFT_LIB_SUFFIX}
 	TINFO_ARG_SUFFIX=${LIB_NAME}${DFT_ARG_SUFFIX}
-	if test "$with_tic_depends" = yes ; then
+	if test "x$with_tic_depends" = xyes ; then
 		TICS_LIST="$SHLIB_LIST -l${LIB_NAME}${DFT_ARG_SUFFIX}"
 	else
 		TICS_LIST="$SHLIB_LIST"
@@ -1785,7 +1785,7 @@
 AC_SUBST(TINFO_LDFLAGS)
 AC_SUBST(TINFO_LIBS)
 
-if test "$with_dlsym" = yes ; then
+if test "x$with_dlsym" = xyes ; then
 	CF_REMOVE_LIB(TICS_LIST,$TICS_LIST,dl)
 fi
 
@@ -1856,18 +1856,18 @@
 CF_ADD_CFLAGS($EXTRA_CFLAGS)
 
 ### Define substitutions for header files to avoid name-pollution
-CF_SUBST_IF(["$cf_cv_have_tcgetattr" = yes], HAVE_TCGETATTR, 1, 0)
-CF_SUBST_IF(["$ac_cv_header_termio_h" = yes], HAVE_TERMIO_H, 1, 0)
-CF_SUBST_IF(["$ac_cv_header_termios_h" = yes], HAVE_TERMIOS_H, 1, 0)
+CF_SUBST_IF(["x$cf_cv_have_tcgetattr" = xyes], HAVE_TCGETATTR, 1, 0)
+CF_SUBST_IF(["x$ac_cv_header_termio_h" = xyes], HAVE_TERMIO_H, 1, 0)
+CF_SUBST_IF(["x$ac_cv_header_termios_h" = xyes], HAVE_TERMIOS_H, 1, 0)
 
 ################################################################################
-test "$use_database" = yes && \
+test "x$use_database" = xyes && \
 SUB_MAKEFILES="$SUB_MAKEFILES misc/run_tic.sh:misc/run_tic.in"
 
 SUB_MAKEFILES="$SUB_MAKEFILES misc/ncurses-config:misc/ncurses-config.in"
 SUB_MAKEFILES="$SUB_MAKEFILES man/ncurses${DFT_ARG_SUFFIX}${cf_cv_abi_version}-config.1:man/MKncu_config.in"
 
-if test x"$enable_pc_files" = xyes ; then \
+if test "x$enable_pc_files" = xyes ; then \
 SUB_MAKEFILES="$SUB_MAKEFILES misc/gen-pkgconfig:misc/gen-pkgconfig.in"
 MAKE_PC_FILES=
 else
Index: dist.mk
Prereq:  1.888 
--- ncurses-5.9-20120826+/dist.mk	2012-08-26 13:32:39.000000000 +0000
+++ ncurses-5.9-20120901/dist.mk	2012-09-01 15:32:47.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.888 2012/08/26 13:32:39 tom Exp $
+# $Id: dist.mk,v 1.889 2012/09/01 15:32:47 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 5
 NCURSES_MINOR = 9
-NCURSES_PATCH = 20120826
+NCURSES_PATCH = 20120901
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: ncurses/curses.priv.h
Prereq:  1.505 
--- ncurses-5.9-20120826+/ncurses/curses.priv.h	2012-08-25 20:49:15.000000000 +0000
+++ ncurses-5.9-20120901/ncurses/curses.priv.h	2012-09-01 19:21:05.000000000 +0000
@@ -34,7 +34,7 @@
  ****************************************************************************/
 
 /*
- * $Id: curses.priv.h,v 1.505 2012/08/25 20:49:15 tom Exp $
+ * $Id: curses.priv.h,v 1.506 2012/09/01 19:21:05 tom Exp $
  *
  *	curses.priv.h
  *
@@ -1451,7 +1451,7 @@
 #define ARG_CH_T	NCURSES_CH_T
 #define CARG_CH_T	NCURSES_CH_T
 #define PUTC_DATA	/* nothing */
-#define PUTC(ch)	NCURSES_SP_NAME(_nc_outch) (NCURSES_SP_ARGx ch)
+#define PUTC(ch)	NCURSES_SP_NAME(_nc_outch) (NCURSES_SP_ARGx (int) ch)
 
 #define BLANK		(' '|A_NORMAL)
 #define ZEROS		('\0'|A_NORMAL)
Index: ncurses/tinfo/access.c
Prereq:  1.22 
--- ncurses-5.9-20120826+/ncurses/tinfo/access.c	2012-02-22 22:34:31.000000000 +0000
+++ ncurses-5.9-20120901/ncurses/tinfo/access.c	2012-09-01 19:21:29.000000000 +0000
@@ -36,7 +36,7 @@
 
 #include <tic.h>
 
-MODULE_ID("$Id: access.c,v 1.22 2012/02/22 22:34:31 tom Exp $")
+MODULE_ID("$Id: access.c,v 1.23 2012/09/01 19:21:29 tom Exp $")
 
 #ifdef __TANDEM
 #define ROOT_UID 65535
@@ -60,7 +60,7 @@
     result = temp;
 #if !MIXEDCASE_FILENAMES
     for (s = result; *s != '\0'; ++s) {
-	*s = LOWERCASE(*s);
+	*s = (char) LOWERCASE(*s);
     }
 #endif
 #if defined(PROG_EXT)
Index: ncurses/tinfo/lib_tputs.c
Prereq:  1.86 
--- ncurses-5.9-20120826+/ncurses/tinfo/lib_tputs.c	2012-08-25 21:22:08.000000000 +0000
+++ ncurses-5.9-20120901/ncurses/tinfo/lib_tputs.c	2012-09-01 23:34:17.000000000 +0000
@@ -51,7 +51,7 @@
 #include <termcap.h>		/* ospeed */
 #include <tic.h>
 
-MODULE_ID("$Id: lib_tputs.c,v 1.86 2012/08/25 21:22:08 tom Exp $")
+MODULE_ID("$Id: lib_tputs.c,v 1.87 2012/09/01 23:34:17 tom Exp $")
 
 NCURSES_EXPORT_VAR(char) PC = 0;              /* used by termcap library */
 NCURSES_EXPORT_VAR(NCURSES_OSPEED) ospeed = 0;        /* used by termcap library */
@@ -119,7 +119,7 @@
 NCURSES_EXPORT(void)
 NCURSES_SP_NAME(_nc_flush) (NCURSES_SP_DCL0)
 {
-    if (SP_PARM->_ofd >= 0) {
+    if (SP_PARM != 0 && SP_PARM->_ofd >= 0) {
 	if (SP_PARM->out_inuse) {
 	    size_t amount = SP->out_inuse;
 	    /*
Index: ncurses/trace/visbuf.c
Prereq:  1.40 
--- ncurses-5.9-20120826+/ncurses/trace/visbuf.c	2012-02-22 22:40:24.000000000 +0000
+++ ncurses-5.9-20120901/ncurses/trace/visbuf.c	2012-09-01 23:53:30.000000000 +0000
@@ -42,7 +42,7 @@
 #include <tic.h>
 #include <ctype.h>
 
-MODULE_ID("$Id: visbuf.c,v 1.40 2012/02/22 22:40:24 tom Exp $")
+MODULE_ID("$Id: visbuf.c,v 1.41 2012/09/01 23:53:30 tom Exp $")
 
 #define NUM_VISBUFS 4
 
@@ -338,7 +338,7 @@
 		{
 		    char temp[80];
 		    VisChar(temp, UChar(buf[j]), sizeof(temp));
-		    result = _nc_trace_bufcat(bufnum, temp);
+		    (void) _nc_trace_bufcat(bufnum, temp);
 		}
 #endif /* USE_WIDEC_SUPPORT */
 	    }
Index: ncurses/tty/hardscroll.c
Prereq:  1.49 
--- ncurses-5.9-20120826+/ncurses/tty/hardscroll.c	2012-02-22 22:40:24.000000000 +0000
+++ ncurses-5.9-20120901/ncurses/tty/hardscroll.c	2012-09-01 23:24:49.000000000 +0000
@@ -147,7 +147,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: hardscroll.c,v 1.49 2012/02/22 22:40:24 tom Exp $")
+MODULE_ID("$Id: hardscroll.c,v 1.50 2012/09/01 23:24:49 tom Exp $")
 
 #if defined(SCROLLDEBUG) || defined(HASHDEBUG)
 
@@ -193,14 +193,21 @@
 #if !defined(SCROLLDEBUG) && !defined(HASHDEBUG)
 #if USE_HASHMAP
     /* get enough storage */
-    if (OLDNUM_SIZE(SP_PARM) < screen_lines(SP_PARM)) {
+    assert(OLDNUM_SIZE(SP_PARM) >= 0);
+    assert(screen_lines(SP_PARM) > 0);
+    if ((oldnums(SP_PARM) == 0)
+	|| (OLDNUM_SIZE(SP_PARM) < screen_lines(SP_PARM))) {
+	int need_lines = ((OLDNUM_SIZE(SP_PARM) < screen_lines(SP_PARM))
+			  ? screen_lines(SP_PARM)
+			  : OLDNUM_SIZE(SP_PARM));
 	int *new_oldnums = typeRealloc(int,
-				       (size_t) screen_lines(SP_PARM),
+				       (size_t) need_lines,
 				       oldnums(SP_PARM));
 	if (!new_oldnums)
 	    return;
+	FreeIfNeeded(oldnums(SP_PARM));
 	oldnums(SP_PARM) = new_oldnums;
-	OLDNUM_SIZE(SP_PARM) = screen_lines(SP_PARM);
+	OLDNUM_SIZE(SP_PARM) = need_lines;
     }
     /* calculate the indices */
     NCURSES_SP_NAME(_nc_hash_map) (NCURSES_SP_ARG);
Index: package/debian/changelog
--- ncurses-5.9-20120826+/package/debian/changelog	2012-08-26 13:34:51.000000000 +0000
+++ ncurses-5.9-20120901/package/debian/changelog	2012-09-01 15:32:47.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (5.9-20120826) unstable; urgency=low
+ncurses6 (5.9-20120901) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 26 Aug 2012 09:34:48 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 01 Sep 2012 11:32:43 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/ncurses.spec
--- ncurses-5.9-20120826+/package/ncurses.spec	2012-08-26 13:34:51.000000000 +0000
+++ ncurses-5.9-20120901/package/ncurses.spec	2012-09-01 15:32:47.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Release: 5.9
-Version: 20120826
+Version: 20120901
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{release}-%{version}.tgz
Index: test/movewindow.c
Prereq:  1.35 
--- ncurses-5.9-20120826+/test/movewindow.c	2012-06-09 20:30:32.000000000 +0000
+++ ncurses-5.9-20120901/test/movewindow.c	2012-09-01 23:54:00.000000000 +0000
@@ -26,7 +26,7 @@
  * authorization.                                                           *
  ****************************************************************************/
 /*
- * $Id: movewindow.c,v 1.35 2012/06/09 20:30:32 tom Exp $
+ * $Id: movewindow.c,v 1.36 2012/09/01 23:54:00 tom Exp $
  *
  * Demonstrate move functions for windows and derived windows from the curses
  * library.
@@ -198,7 +198,6 @@
 			i = event.y - uli;
 			j = event.x - ulj;
 		    }
-		    moved = TRUE;
 		} else {
 		    beep();
 		    break;
